#ifndef _BINARY_SEARCH_TREE_H_
#define _BINARY_SEARCH_TREE_H_
#include <stddef.h>

typedef struct BinarySearchTree_t BinarySearchTree;
BinarySearchTree* createEmptyBinarySearchTree(void);
BinarySearchTree* createBinarySearchTree(int* keys, const void** values, size_t numElements);
void freeBinarySearchTree(BinarySearchTree* tree);
size_t getNumElements(const BinarySearchTree* tree);
const void* insertElement(BinarySearchTree* tree, int key, const void* value);
const void* removeElement(BinarySearchTree* tree, int key);
const void* findElement(const BinarySearchTree* tree, int key);
int getRankOf(const BinarySearchTree* tree, int key);
size_t getElementsInRange(const BinarySearchTree* tree, int keyMin, int keyMax, const void*** results);

#endif // _BINARY_SEARCH_TREE_H_

