/* 
 * File:   Averager.hpp
 * Author: Thibaut Cuvelier
 *
 * Implements a simple averager on unsigned char. 
 */

#ifndef AVERAGER_HPP
#define	AVERAGER_HPP

class Averager {
public:
  Averager();
  ~Averager();
  
  // Adds a number to the list of those to average. 
  void add(unsigned char number); 
  // Gets the average of all the added numbers. 
  unsigned char average() const;

private:  
  unsigned long accumulator_; 
  unsigned long number_; 
};

#endif	/* AVERAGER_HPP */
