/** 
 * Insertion sort
 */ 

#include <stddef.h>
#include <stdio.h>

/**
 * Insertion sort the array. 
 * 
 * @param arr		the array to sort
 * @param length	the size of the array
 * @param compare	the comparator to use
 */ 
void Sort(const void** arr, size_t length, int (*compare)(const void*, const void*))
{
	// Invariant: at each iteration, all array elements are sorted up to i (included). 
    for(size_t i = 1; i < length; ++i) {
        int j = i; 
        
		/* As long as the element is greater than the current comparated 
		   element, swap. */
        while(j > 0 && compare(arr[j-1], arr[j]) > 0) {
            const void* tmp  = arr[j]; 
            arr[j] = arr[j-1]; 
            arr[j-1] = tmp; 
            
            j--; 
        }
    }
}
